%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% INTELLLIGENT IMAGE ANNOTATION TOOL FOR AERIAL SURVEILLANCE VIDEO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% AUTHOR : Ravishankar Sivalingam
% DATE   : November 18th 2009
% EMAIL  : sival001@umn.edu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% REQUIREMENTS : Image Processing Toolbox
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%
% Please e-mail me at sival001@umn.edu if you find any errors or problems, or need help with
% troubleshooting.
% Thank you very much,
% Ravi
%











%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% MAIN OPEN/CLOSE FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function varargout = ImageAnnotator(varargin)
% IMAGEANNOTATOR M-file for ImageAnnotator.fig
%      IMAGEANNOTATOR, by itself, creates a new IMAGEANNOTATOR or raises the existing
%      singleton*.
%
%      H = IMAGEANNOTATOR returns the handle to a new IMAGEANNOTATOR or the handle to
%      the existing singleton*.
%
%      IMAGEANNOTATOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in IMAGEANNOTATOR.M with the given input arguments.
%
%      IMAGEANNOTATOR('Property','Value',...) creates a new IMAGEANNOTATOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ImageAnnotator_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ImageAnnotator_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ImageAnnotator

% Last Modified by GUIDE v2.5 17-Nov-2009 18:41:23

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ImageAnnotator_OpeningFcn, ...
    'gui_OutputFcn',  @ImageAnnotator_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes just before ImageAnnotator is made visible.
function ImageAnnotator_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<*INUSL>
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ImageAnnotator (see VARARGIN)
% clc
% Choose default command line output for ImageAnnotator
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ImageAnnotator wait for user response (see UIRESUME)
% uiwait(handles.figure1);

set(handles.pbPrevious,'CData',imread('images\prev.bmp'));
set(handles.pbNext,'CData',imread('images\next.bmp'));

handles.labelFileName = 'labelfile.mat'; % HARDCODED label file name
if exist(handles.labelFileName,'file')
    load(handles.labelFileName,'labels');
    handles.labels = labels; %#ok<NODEF>
else
    warndlg('Universal label list file not found!! Creating new label file...','Label File Not Found!!!');
    labels = {}; save(handles.labelFileName,'labels');
    handles.labels = labels;
end
% no file has been loaded yet
handles.fileLoaded = false;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Outputs from this function are returned to the command line.
function varargout = ImageAnnotator_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.fileLoaded
    button = questdlg('Do you want to save the annotations entered in this session?','Save Before Exit?','Yes');
    if strcmpi(button,'Yes')
        h = waitbar(0,'Saving data... Please wait');
        annots = handles.annots;
        for i = 1:length(annots.labeledFlag)
            if nnz(annots.masks{i})
                annots.labeledFlag(i) = true;
            else
                annots.labeledFlag(i) = false;
            end
            waitbar(0.5*(i/length(annots.labeledFlag)),h);
        end
        imgdesc = handles.imgdesc; %#ok<NASGU>
        save(handles.matfilename,'annots','imgdesc');
        waitbar(0.95,h,'Saved current video annotations!');
        % save the labels into its own MAT file
        labels = handles.labels; save(handles.labelFileName,'labels'); %#ok<NASGU>
        waitbar(1,h,'Saved universal label list!');
        % Hint: delete(hObject) closes the figure
        waitbar(1.0,h,'Done! Thank you for waiting!'); pause(0.1); close(h);
        delete(hObject);
    elseif strcmpi(button,'No')
        % Hint: delete(hObject) closes the figure
        delete(hObject);
    end
else
    % Hint: delete(hObject) closes the figure
    delete(hObject);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% CHECK BOXES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in cbOverlay.
function cbOverlay_Callback(hObject, eventdata, handles)
% hObject    handle to cbOverlay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of cbOverlay
if isempty(handles.annots.masks{handles.framenum})
    handles.annots.masks{handles.framenum} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
end
handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(hObject,'Value'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in cbLoaded.
function cbLoaded_Callback(hObject, eventdata, handles)
% hObject    handle to cbLoaded (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of cbLoaded
if get(hObject,'Value')
    [FileName,PathName] = uigetfile({'*_trainedAnnotator.mat'},'Select the trained Annotator', 'MultiSelect', 'Off');
    load(fullfile(PathName,FileName),'Annotator');
    handles.Annotator = Annotator;
    % msgbox('Annotator has been loaded!','LOADED!');
else
    handles.Annotator = [];
    % msgbox('Annotator has been unloaded!','UNLOADED!');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% PUSH BUTTONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbLoadVideo.
function pbLoadVideo_Callback(hObject, eventdata, handles)
% hObject    handle to pbLoadVideo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if handles.fileLoaded
    button = questdlg('Do you want to save the annotations entered in this session?','Save Before Exit?','Yes');
    if strcmpi(button,'Yes')
        h = waitbar(0,'Saving data... Please wait');
        annots = handles.annots;
        for i = 1:length(annots.labeledFlag)
            if nnz(annots.masks{i})
                annots.labeledFlag(i) = true;
            else
                annots.labeledFlag(i) = false;
            end
            waitbar(0.5*(i/length(annots.labeledFlag)),h);
        end
        imgdesc = handles.imgdesc; %#ok<NASGU>
        save(handles.matfilename,'annots','imgdesc');
        waitbar(0.95,h,'Saved current video annotations!');
        % save the labels into its own MAT file
        labels = handles.labels; save(handles.labelFileName,'labels'); %#ok<NASGU>
        waitbar(1,h,'Saved universal label list!');
        % Hint: delete(hObject) closes the figure
        waitbar(1.0,h,'Done! Thank you for waiting!'); pause(0.1); close(h);
        delete(hObject);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Open standard dialog box for retrieving files
% Select AVI file
[FileName,PathName] = uigetfile({'*.avi;*.mpg;*.mp4;*.wmv','Video Files (*.avi, *.mpg, *.mp4, *.wmv)';'*.*','All Files (*.*)'},'Select the video', 'MultiSelect', 'Off');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if FileName == 0
    return
end
% save the video file name into handles structure
handles.FileName = FileName;
handles.PathName = PathName;
handles.fullfilename = fullfile(PathName,FileName);
handles.matfilename = [handles.FileName(1:end-3) 'mat'];

handles.fname = FileName;
handles.fileLoaded = true;
% read in the 1st frame in the video
handles.framenum = 1;
% [handles.img,handles.vidinfo] = vaceread(handles.fullfilename,handles.framenum);
[handles.img,handles.vidinfo,handles.fullfilename] = LoadImage(handles.fullfilename,handles.framenum);
% display it on the axes
set( handles.imgAxes,        'Visible', 'On'); axes(handles.imgAxes); imshow(handles.img,[]);
set( handles.tbframeNum,     'String', num2str(handles.framenum));
set( handles.tbTotalFrames,  'String', [' of ' num2str(handles.vidinfo.NumFrames)]);
set( handles.pbPrevious,     'Enable', 'On');
set( handles.pbNext,         'Enable', 'On');
set( handles.pbFill,         'Enable', 'On');
set( handles.pbFillAll,      'Enable', 'On');
set( handles.pbProp,         'Enable', 'On');
set( handles.pbDelete,       'Enable', 'On');
set( handles.pbDelAll,       'Enable', 'On');
set( handles.tbframeNum,     'Enable', 'On');
set( handles.tbStartAnnot,   'Enable', 'On', 'Value' ,0);
set( handles.cbOverlay,      'Enable', 'On', 'Value', 0);
set( handles.pbSuggAnnot,    'Enable', 'On');
set( handles.pbSegment,      'Enable', 'On');
set( handles.pbTest,         'Enable', 'On');

handles.suggAnnots = [];

if exist(handles.matfilename,'file')
    % load the saved annotations from the MAT file
    load(handles.matfilename)
else
    % if this is not available, warn the user about creating a new MAT file
    warndlg([handles.matfilename ' not found!! Creating new MAT file...'],'File Not Found!!!')

    imgdesc = repmat(struct('simg',[],'segments',[],'area',[],'covmats',[],'annot',[]),handles.vidinfo.NumFrames,1);
    annots.masks = repmat({[]},handles.vidinfo.NumFrames,1);
    annots.labeledFlag = false(handles.vidinfo.NumFrames,1);
    annots.masks{handles.framenum} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
    save(handles.matfilename,'annots');
end
handles.annots = annots;
handles.imgdesc = imgdesc;
set(handles.imgAxes,'Units','Pixels');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbPrevious.
function pbPrevious_Callback(hObject, eventdata, handles)
% hObject    handle to pbPrevious (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.framenum = max(handles.framenum-1,1);
set(handles.tbframeNum,'String',num2str(handles.framenum));
% handles.img = vaceread(handles.fullfilename,handles.framenum);
handles.img = LoadImage(handles.fullfilename,handles.framenum,handles.vidinfo);
if isempty(handles.annots.masks{handles.framenum})
    handles.annots.masks{handles.framenum} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
end
handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
handles.suggAnnots = [];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbNext.
function pbNext_Callback(hObject, eventdata, handles)
% hObject    handle to pbNext (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.framenum = min(handles.framenum+1,handles.vidinfo.NumFrames);
set(handles.tbframeNum,'String',num2str(handles.framenum));
% handles.img = vaceread(handles.fullfilename,handles.framenum);
handles.img = LoadImage(handles.fullfilename,handles.framenum,handles.vidinfo);
if isempty(handles.annots.masks{handles.framenum})
    handles.annots.masks{handles.framenum} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
end
handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
handles.suggAnnots = [];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in tbStartAnnot.
function tbStartAnnot_Callback(hObject, eventdata, handles)
% hObject    handle to tbStartAnnot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of tbStartAnnot

if get(hObject,'Value')
    set(hObject,'String','Hit Esc To Stop');
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if isempty(handles.annots.masks{handles.framenum})
        I = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
    else
        I = handles.annots.masks{handles.framenum};
    end
    if isempty(handles.imgdesc(handles.framenum).simg)
        imgdesc = ComputeSuperPixels(handles.img);
    else
        imgdesc = handles.imgdesc(handles.framenum);
    end
    while 1
        axes(handles.imgAxes);
        try
            [x,y,BW,xi,yi] = roipoly(handles.img);  % get the polygonal region-of-interest
        catch ME
            err = regexp(ME.identifier, '(?<=:)\w+$','match');
            if strcmpi(err,'badsubscript')
                break;
            end
        end
        if isempty(yi)
            break;
        end
        [selxn,ok] = listdlg('PromptString','Enter annotation : ','SelectionMode','single','Name','Annotation','ListString', [{'Enter new label..'} handles.labels] );
        num = selxn - 1; % find the index of the current label from the list of labels
        if ok == 1
            if num == 0 % this label hasn't been entered before
                curr_label = inputdlg('Enter label : ','Annotation');   % get annotation label from user
                if isempty(curr_label)
                    break
                end
                handles.labels(end+1) = curr_label;  % save this label to the list of all labels
                num = length(handles.labels);    % index of this new label
            end
        else
            break;
        end
        t = unique(I(I~=0 & BW));   % find which previous annotation conflict with this one
        if isempty(t)   % if none conflict
            I(BW) = num;    % just apply this annotation
        else    % if at least one previous annotation conflicts
            t = t(1); % right now using 1st conflict - need to consider case of multiple conflicts
            if nnz(I==t) > nnz(BW)  % if the previously annotated region is larger
                I(BW) = num; % the new region gets the annotation of the new smaller region
                % I(I~=0 & BW) = num; % this was wrong
            else    % if the previously annotated region is smaller
                I(I~=t & BW) = num; % the new region gets the annotation of the old smaller region
            end     % end if
        end     % end if
        % save the annotations here
        handles.annots.masks{handles.framenum} = I;
        handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
    end     % while
    % save the annotations here
    handles.annots.masks{handles.framenum} = I;
    handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
    set(hObject,'String','Start Annotation','Value',0);
    % if there are any annotations at all in this image, mark it as having annotations in
    % labeledFlag
    if nnz(handles.annots.masks{handles.framenum})
        handles.annots.labeledFlag(handles.framenum) = true;
        imgdesc = assignAnnotations(handles.annots.masks{handles.framenum},imgdesc,handles.labels);
        handles.imgdesc(handles.framenum) = imgdesc;
    else
        handles.annots.labeledFlag(handles.framenum) = false;
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbSegment.
function pbSegment_Callback(hObject, eventdata, handles)
% hObject    handle to pbSegment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isempty(handles.imgdesc(handles.framenum).simg)
    imgdesc = ComputeSuperPixels(handles.img);
else
    imgdesc = handles.imgdesc(handles.framenum);
end
mask = imgdesc.simg;
axes(handles.imgAxes); hold off; imshow(handles.img,[]); hold on; h = imagesc(mask,[0 max(max(mask(:)),4)]); cmap = colormap; cmap(1,3) = 0; colormap(cmap); set(h,'AlphaData',0.5);
title(handles.imgAxes,'Click on the regions which you wish to label. Right-click when done.');
if isempty(handles.annots.masks{handles.framenum})
    I = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
else
    I = handles.annots.masks{handles.framenum};
end
[x,y,button] = ginput(1);
while button == 1
    x = round(x); y = round(y);
    BW = bwselect(mask == mask(y,x),x,y,8);

    [selxn,ok] = listdlg('PromptString','Enter annotation : ','SelectionMode','single','Name','Annotation','ListString', [{'Enter new label..'} handles.labels] );
    num = selxn - 1; % find the index of the current label from the list of labels
    if ok == 1
        if num == 0 % this label hasn't been entered before
            curr_label = inputdlg('Enter label : ','Annotation');   % get annotation label from user
            if isempty(curr_label)
                break
            end
            handles.labels(end+1) = curr_label;  % save this label to the list of all labels
            num = length(handles.labels);    % index of this new label
        end
    else
        break;
    end
    t = unique(I(I~=0 & BW));   % find which previous annotation conflict with this one
    if isempty(t)   % if none conflict
        I(BW) = num;    % just apply this annotation
    else    % if at least one previous annotation conflicts
        t = t(1); % right now using 1st conflict - need to consider case of multiple conflicts
        if nnz(I==t) > nnz(BW)  % if the previously annotated region is larger
            I(BW) = num; % the new region gets the annotation of the new smaller region
            % I(I~=0 & BW) = num; % this was wrong
        else    % if the previously annotated region is smaller
            I(I~=t & BW) = num; % the new region gets the annotation of the old smaller region
        end     % end if
    end     % end if
    handles.annots.masks{handles.framenum} = I;
    handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, true);
    title(handles.imgAxes,'Updated annotation for current image'); %drawnow;
    pause(0.1);
    mask(BW) = 0;
    axes(handles.imgAxes); hold off; imshow(handles.img,[]); hold on; h = imagesc(mask,[0 max(max(mask(:)),4)]); cmap = colormap; cmap(1,3) = 0; colormap(cmap); set(h,'AlphaData',0.5);
    title(handles.imgAxes,'Click on the regions which you wish to label. Right-click when done.');
    [x,y,button] = ginput(1);
end
DisplayOverlay(handles.labels, handles.img,handles.annots.masks{handles.framenum},handles.imgAxes,get(handles.cbOverlay,'Value'));
if nnz(handles.annots.masks{handles.framenum})
    handles.annots.labeledFlag(handles.framenum) = true;
    imgdesc = assignAnnotations(handles.annots.masks{handles.framenum},imgdesc,handles.labels);
    handles.imgdesc(handles.framenum) = imgdesc;
else
    handles.annots.labeledFlag(handles.framenum) = false;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbSuggAnnot.
function pbSuggAnnot_Callback(hObject, eventdata, handles)
% hObject    handle to pbSuggAnnot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of pbSuggAnnot
if isempty(handles.annots.masks{handles.framenum})
    handles.annots.masks{handles.framenum} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
end
if isempty(handles.imgdesc(handles.framenum).simg)
    imgdesc = ComputeSuperPixels(handles.img);
else
    imgdesc = handles.imgdesc(handles.framenum);
end
saveOverlay = get(handles.cbOverlay,'Value');
set(handles.cbOverlay,'Value',0);
% find the nearest frame to suggest annotations from
if isempty(handles.suggAnnots)
    nearFrame = findNearFrame(handles.framenum,handles.annots.labeledFlag);
    if isempty(nearFrame)
        errordlg('There is no nearby labeled frame to suggest from!','No Suggestions!','modal');
        % if there are any annotations at all in this image, mark it as having annotations in
        % labeledFlag
        if nnz(handles.annots.masks{handles.framenum})
            handles.annots.labeledFlag(handles.framenum) = true;
        else
            handles.annots.labeledFlag(handles.framenum) = false;
        end
        set(hObject,'Value',0);
        set(handles.cbOverlay,'Value',saveOverlay);
        DisplayOverlay(handles.labels, handles.img,handles.annots.masks{handles.framenum},handles.imgAxes,saveOverlay);
        return;
    end
    nearFrame = nearFrame(1);
    prev_img = im2double(LoadImage(handles.fullfilename,nearFrame,handles.vidinfo)); img = im2double(handles.img);
    M = estimateAffineTransformHarris(img,prev_img); tform = maketform('affine',inv(M)'); clear img prev_img;
    handles.suggAnnots = imtransform(handles.annots.masks{nearFrame},tform,'nearest',...
        'XData',[1 handles.vidinfo.Width],'YData',[1 handles.vidinfo.Height]);
end
DisplayOverlay(handles.labels, handles.img,handles.suggAnnots,handles.imgAxes,true);

button = questdlg('Do you want to use all the annotations suggested?','Use All ??? ','Yes','No','No');
if strcmpi(button,'Yes')
    handles.annots.masks{handles.framenum} = handles.suggAnnots;
else
    title(handles.imgAxes,'Click on the suggested annotations which you wish to use. Right-click when done.'); drawnow;
    [x,y,button] = ginput(1);
    while button == 1
        x = round(x); y = round(y);
        BW = bwselect(handles.suggAnnots == handles.suggAnnots(y,x),x,y,8);
        handles.annots.masks{handles.framenum}(BW) = handles.suggAnnots(y,x);
        handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, true);
        title(handles.imgAxes,'Updated annotation for current image'); %drawnow;
        pause(0.01);
        handles.suggAnnots(BW) = 0;
        DisplayOverlay(handles.labels, handles.img,handles.suggAnnots,handles.imgAxes,true);
        title(handles.imgAxes,'Click on the suggested annotations which you wish to use. Right-click when done.'); drawnow;
        [x,y,button] = ginput(1);
    end
end
% if there are any annotations at all in this image, mark it as having annotations in labeledFlag
if nnz(handles.annots.masks{handles.framenum})
    handles.annots.labeledFlag(handles.framenum) = true;
    imgdesc = assignAnnotations(handles.annots.masks{handles.framenum},imgdesc,handles.labels);
    handles.imgdesc(handles.framenum) = imgdesc;
else
    handles.annots.labeledFlag(handles.framenum) = false;
end
set(hObject,'Value',0);
set(handles.cbOverlay,'Value',saveOverlay);
DisplayOverlay(handles.labels, handles.img,handles.annots.masks{handles.framenum},handles.imgAxes,saveOverlay);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbFill.
function pbFill_Callback(hObject, eventdata, handles)
% hObject    handle to pbFill (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~isempty(handles.annots.masks{handles.framenum})
    button = questdlg('Are you sure you want to flood-fill the annotations?','Are you sure?','Yes','No','No');
    if strcmpi(button,'yes')
        BW = handles.annots.masks{handles.framenum};
        [D,L] = bwdist(BW);
        D = BW(L);
        handles.annots.masks{handles.framenum} = D;
        handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, true);
        title('Filled out annotation labels'); pause(1);
        handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbFillAll.
function pbFillAll_Callback(hObject, eventdata, handles)
% hObject    handle to pbFillAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
button = questdlg('Are you sure you want to flood-fill the annotations of the entire video?','Are you sure?','Yes','No','No');
if strcmpi(button,'yes')
    count = 0;
    h = waitbar(0,'Filling in all frames...');
    for framenum = 1:handles.vidinfo.NumFrames
        waitbar(framenum/handles.vidinfo.NumFrames,h,['Filling in frame ' num2str(framenum) '...']); drawnow;
        if handles.annots.labeledFlag(framenum) && nnz(handles.annots.masks{framenum}==0)
            count = count + 1;
            BW = handles.annots.masks{framenum};
            [D,L] = bwdist(BW);
            D = BW(L);
            handles.annots.masks{framenum} = D;
        else
            continue
        end
    end
end
handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
close(h); msgbox(['Filled ' num2str(count) ' frames!']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbDelete.
function pbDelete_Callback(hObject, eventdata, handles)
% hObject    handle to pbDelete (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete annotation
saveOverlay = get(handles.cbOverlay,'Value'); set(handles.cbOverlay,'Value',1);
handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, true);
title(handles.imgAxes,'Click on the annotations which you wish to delete. Right-click when done.'); drawnow;
[x,y,button] = ginput(1);
while button == 1
    x = round(x); y = round(y);
    BW = bwselect(handles.annots.masks{handles.framenum} == handles.annots.masks{handles.framenum}(y,x),x,y,8);
    handles.annots.masks{handles.framenum}(BW) = 0;
    handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, true);
    title(handles.imgAxes,'Click on the annotations which you wish to delete. Right-click when done.'); drawnow;
    [x,y,button] = ginput(1);
end
% if there are any annotations at all in this image, mark it as having annotations in
% labeledFlag
if nnz(handles.annots.masks{handles.framenum})
    handles.annots.labeledFlag(handles.framenum) = true;
else
    handles.annots.labeledFlag(handles.framenum) = false;
end
set(handles.cbOverlay,'Value',saveOverlay);
handles.alphaMask = DisplayOverlay(handles.labels, handles.img,handles.annots.masks{handles.framenum},handles.imgAxes,saveOverlay);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbDelAll.
function pbDelAll_Callback(hObject, eventdata, handles)
% hObject    handle to pbDelAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
button = questdlg('Are you sure you want to delete all the annotations in this image?','Are you sure?','Yes','No','No');
if strcmpi(button,'yes')
    handles.annots.masks{handles.framenum} = [];
    handles.annots.labeledFlag(handles.framenum) = false;
end
handles.alphaMask = DisplayOverlay(handles.labels, handles.img,handles.annots.masks{handles.framenum},handles.imgAxes,get(handles.cbOverlay,'Value'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbProp.
function pbProp_Callback(hObject, eventdata, handles)
% hObject    handle to pbProp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h = waitbar(0,'Propagating labels to next 10 frames...');
set(h,'Units','normalized');pos = get(h,'Position'); set(h,'Position',[pos(1) pos(2)+0.2 pos(3:4)]); set(h,'Units','Pixels');
curr_img = im2double(handles.img); [corners.FP,corners.wind] = harrisCornerDetector(curr_img);
for i = 1:10
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if isempty(handles.annots.masks{handles.framenum+i})
        handles.annots.masks{handles.framenum+i} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
    end
    if isempty(handles.imgdesc(handles.framenum+i).simg)
        imgdesc = ComputeSuperPixels(handles.img);
    else
        imgdesc = handles.imgdesc(handles.framenum+i);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    prev_img = curr_img;
    curr_img = im2double(LoadImage(handles.fullfilename,handles.framenum+i,handles.vidinfo));
    [M,corners] = estimateAffineTransformHarris(curr_img,prev_img,corners); tform = maketform('affine',inv(M)');
    handles.suggAnnots = imtransform(handles.annots.masks{handles.framenum},tform,'nearest',...
        'XData',[1 handles.vidinfo.Width],'YData',[1 handles.vidinfo.Height]);
    handles.annots.masks{handles.framenum+i} = handles.suggAnnots;
    handles.annots.labeledFlag(handles.framenum+i) = true;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    imgdesc = assignAnnotations(handles.annots.masks{handles.framenum+i},imgdesc,handles.labels);
    handles.imgdesc(handles.framenum+i) = imgdesc;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    waitbar(i/10,h,sprintf('Propagated frames %d of %d...',i,10))
end
close(h);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbTrain.
function pbTrain_Callback(hObject, eventdata, handles)
% hObject    handle to pbTrain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

button = questdlg('Do you want to save the annotations entered in this session?','Save Before Exit?','Yes');
if strcmpi(button,'Yes')
    h = waitbar(0,'Saving data... Please wait');
    annots = handles.annots;
    for i = 1:length(annots.labeledFlag)
        if nnz(annots.masks{i})
            annots.labeledFlag(i) = true;
        else
            annots.labeledFlag(i) = false;
        end
        waitbar(0.5*(i/length(annots.labeledFlag)),h);
    end
    imgdesc = handles.imgdesc; %#ok<NASGU>
    save(handles.matfilename,'annots','imgdesc');
    waitbar(0.95,h,'Saved current video annotations!');
    % save the labels into its own MAT file
    labels = handles.labels; save(handles.labelFileName,'labels'); %#ok<NASGU>
    waitbar(1,h,'Saved universal label list!');
    % Hint: delete(hObject) closes the figure
    waitbar(1.0,h,'Done! Thank you for waiting!'); pause(0.1); close(h);
end

[FileName,PathName] = uigetfile({'*.mat'},'Select the training data files', 'MultiSelect', 'On');
if ~iscell(FileName)
    trainingdata = load(fullfile(PathName,FileName),'imgdesc'); trainingdata.imgdesc = trainingdata.imgdesc';
else
    for i = 1:length(FileName)
        trainingdata(i) = load(fullfile(PathName,FileName{i}),'imgdesc'); trainingdata(i).imgdesc = trainingdata(i).imgdesc';
    end
end
allImageDescriptors = [trainingdata(:).imgdesc];
dset.annot = [allImageDescriptors.annot];
Annotator.X = [allImageDescriptors.covmats];
Annotator.dim = size(Annotator.X{1},1);
[Annotator.Y,Annotator.indicatorMatrix,Annotator.histY,Annotator.labels] = histWords(dset.annot,handles.labels);
Annotator.X(Annotator.Y==0) = [];
Annotator.indicatorMatrix(Annotator.Y==0,:) = [];
Annotator.Y(Annotator.Y==0) = [];
Annotator.N = length(Annotator.X);
Annotator.K = length(Annotator.labels);
Annotator.sig2 = learnKDEbandwidth(Annotator.X,Annotator.Y,Annotator.K);
Annotator.COMat = createCoOccurrenceMatrix(allImageDescriptors,Annotator.labels);
trainedAnnotatorFilename = strrep(handles.FileName,'.avi','_trainedAnnotator.mat');
save(trainedAnnotatorFilename,'Annotator');
clear Annotator;
handles.Annotator = [];
% msgbox('Annotator has been unloaded!','UNLOADED!'); set(handles.cbLoaded,'Value',0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pbTest.
function pbTest_Callback(hObject, eventdata, handles)
% hObject    handle to pbTest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~get(handles.cbLoaded,'Value') || ~isfield(handles,'Annotator')
    [FileName,PathName] = uigetfile({'*_trainedAnnotator.mat'},'Select the trained Annotator', 'MultiSelect', 'Off');
    load(fullfile(PathName,FileName),'Annotator');
    handles.Annotator = Annotator;
    % msgbox('Annotator has been loaded!','LOADED!');
    set(handles.cbLoaded,'Value',1);
end
tic
performAutomaticAnnotation(handles.img,handles.Annotator,handles.imgAxes,handles);
toc
F = getframe(handles.imgAxes);
imwrite(F.cdata,['images\' handles.FileName '_image' num2str(handles.framenum) '.jpg']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% EDIT BOXES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on editing tbframeNum
function tbframeNum_Callback(hObject, eventdata, handles)
% hObject    handle to tbframeNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of tbframeNum as text
%        str2double(get(hObject,'String')) returns contents of tbframeNum as a double
handles.framenum = str2double(get(hObject,'String'));
if handles.framenum < 1
    set(hObject,'String',num2str(1));
    handles.framenum = 1;
end
if handles.framenum > handles.vidinfo.NumFrames
    set(hObject,'String',num2str(handles.vidinfo.NumFrames));
    handles.framenum = handles.vidinfo.NumFrames;
end
% handles.img = vaceread(handles.fullfilename,handles.framenum);
handles.img = LoadImage(handles.fullfilename,handles.framenum,handles.vidinfo);
% display it on the axes
axes(handles.imgAxes); imshow(handles.img);
handles.suggAnnots = [];
if isempty(handles.annots.masks{handles.framenum})
    handles.annots.masks{handles.framenum} = zeros(handles.vidinfo.Height,handles.vidinfo.Width);
end
handles.alphaMask = DisplayOverlay(handles.labels, handles.img, handles.annots.masks{handles.framenum}, handles.imgAxes, get(handles.cbOverlay,'Value'));
handles.suggAnnots = [];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% 'USELESS' CREATE FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function tbframeNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tbframeNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% AUXILIARY FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Displays the annotation overlay
function alphaMask = DisplayOverlay(labels,img,mask,imgAxes,flag)
% img = handles.img
% mask = handles.annots.masks{handles.framenum}
% imgAxes = handles.imgAxes
% alphaMask = handles.alphaMask
% flag = handles.cbOverlay's Value
if isempty(mask)
    axes(imgAxes); hold off; imshow(img,[]);
    alphaMask = []; return;
end
alphaMask = GetAlphaMask(mask);
if flag && nnz(mask)
    axes(imgAxes); hold off; imshow(img,[]); hold on;
    h = imagesc(mask,[0 max(max(mask(:)),4)]);
    cmap = colormap; cmap(1,3) = 0; colormap(cmap);
    set(h,'AlphaData',alphaMask);

    lab_uniq = unique(mask(:)); lab_uniq(lab_uniq==0) = [];
    for i = 1:length(lab_uniq)
        L = bwlabel(mask==lab_uniq(i),4); rp = regionprops(L);
        for j = 1:length(rp)
            if rp(j).Area > 50
                rp(j).Centroid = round(rp(j).Centroid);
                % while mask(rp(j).Centroid(2),rp(j).Centroid(1)-5)~=lab_uniq(i)
                %      rp(j).Centroid(1) = rp(j).Centroid(1) + 1;
                % end
                if mask(rp(j).Centroid(2),rp(j).Centroid(1))~=lab_uniq(i)
                    [i2,i1] = find(imerode(mask==lab_uniq(i),ones(5)));
                    dist_vec = (rp(j).Centroid(2) - i2).^2 + (rp(j).Centroid(1) - i1).^2;
                    ind = find(dist_vec==min(dist_vec),1);
                    rp(j).Centroid(1) = i1(ind); rp(j).Centroid(2) = i2(ind);
                end
                text(rp(j).Centroid(1)-5,rp(j).Centroid(2),labels{lab_uniq(i)},'FontSize',12,'FontWeight','bold','FontName','TimesNewRoman');
            end
        end
    end
else
    axes(imgAxes); hold off; imshow(img,[]);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Computes the alpha mask to display the annotation overlay
function finalAlphaMask = GetAlphaMask(BWannots)
% BWannots is the annotation mask from handles.annots.masks{i} for the i-th frame
alphaMask = false(size(BWannots));
finalAlphaMask = zeros(size(BWannots));
uniqAnnots = unique(BWannots(:)); uniqAnnots(uniqAnnots==0) = [];
str_el = ones(3); borderAlpha = 0.7; interiorAlpha = 0.3;
for i = 1:length(uniqAnnots)
    alphaMask = alphaMask | imdilate(bwperim(BWannots==i),str_el);
end
finalAlphaMask(BWannots==0) = 0;
finalAlphaMask(alphaMask==1) = borderAlpha;
finalAlphaMask(alphaMask==0) = interiorAlpha;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Finds nearest labeled frame to suggest annotations from
function nearFrame = findNearFrame(fnum,labeledFlag)
% fnum = handles.framenum
% labeledFlag = handles.annots.labeledFlag
gap = 5; % +/- 2 frames
ind = (max(fnum - gap, 1) : min(fnum + gap,length(labeledFlag)))';
ind(ind==fnum) = [];
indFlag = labeledFlag(ind);
tempIndFlag = ind(logical(indFlag));
nearFrame = tempIndFlag( abs(tempIndFlag-fnum) == min(abs(tempIndFlag-fnum)) );
nearFrame(nearFrame==fnum) = [];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Estimates affine transform based on Harris corners
function [M,newHarris] = estimateAffineTransformHarris(I1,I2,varargin)
h = waitbar(0,'Estimating transformation from adjacent image...');
sigma = 2;
corr_th = 0.75;
C = [];
minMatches = 5;

if nargin > 2
    oldHarris = varargin{1};
    FP1 = oldHarris.FP; wind1 = oldHarris.wind;
else
    % Harris corners from the first image
    [FP1,wind1] = harrisCornerDetector(I1);
end
waitbar(0.35);
if nargin > 3
    options = varargin{2};
    if isfield(options,'sigma'),        sigma = options.sigma;              end
    if isfield(options,'corr_th'),      corr_th = options.corr_th;          end
    if isfield(options,'minMatches'),   minMatches = options.minMatches;    end
end

% Harris corners from the second image
[FP2,wind2] = harrisCornerDetector(I2);
waitbar(0.70);
while nnz(C) < minMatches
    % double the sigma value for the SVD feature matching to get atleast a minimum number of control
    % point matches
    sigma = 2*sigma;

    % compute feature correspondences based on the SVD method
    C = svdFeatCorresp(FP1, FP2, wind1, wind2, sigma, corr_th);
    % sigma = 2 - adjust point interaction (expected displacement)
    % corr_th = 0.75 - minimum acceptable correlation for a match
    [b,c] = find(C);
end
waitbar(0.80);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% compute the affine transform from these matched points
p0 = FP1(b,[2 1])';
p1 = FP2(c,[2 1])';
wts = ones(1,size(p0,2));
est_outlier_rate = 0.2;
M = fit_robust_affine_transform( p0, p1, wts, est_outlier_rate );
waitbar(0.90);
newHarris.FP = FP2; newHarris.wind = wind2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
waitbar(0.95); close(h);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Fits a robust affine transform from the point sets p0 and p1
function [aff,outliers,robustError,affsave,residsave] = fit_robust_affine_transform( p0, p1, wght, est_outlier_rate_or_init_aff )

% [aff] = fit_robust_affine_transform( p0, p1 )
%
% Robustly compute the affine transformation that takes points
% p0 to points p1 using RANSAC and reweigted least squares.
%
% Input:
% p0 - initial points stores as an 2xn matrix.
% p1 - points after transformation.
% wght - weight of each constraint.
% est_outlier_rate_or_init_aff - the estimated outlier rate or
%   the initial affinie transform.  It an outlier rate is specified,
%   RANSAC is used to get an initial guess.  If an affine transform is
%   specified, it is used instead.
%
% Output:
% aff - affine tranformation embeded in a 3x3 matrix.
% outliers - indices of the outliers to the estimated
%   transformation.
% robustError - robust error of the fit.
%
% Thomas F. El-Maraghi
% May 2004

if ~exist('wght','var')
    wght = ones(1,size(p0,2));
end

if ~exist('est_outlier_rate_or_init_aff','var')
    est_outlier_rate = 0.5;
else
    if length(est_outlier_rate_or_init_aff(:)) == 1
        est_outlier_rate = est_outlier_rate_or_init_aff;
    else
        init_aff = est_outlier_rate_or_init_aff;
    end
end

% Check that there are enough constraints
n = size(p0,2);
if n < 3
    error( 'Too few contraints to fit affine tranform.' );
end

if ~exist('init_aff','var')
    % Perform RANSAC to generate initial guess for the
    % affine transformation
    num_guesses = ceil(1.0/(1.0-est_outlier_rate)^3);
    % best_seed = zeros(3,1);
    best_median = Inf;
    best_aff = zeros(3,1);
    for kk = 1:num_guesses
        % Select 3 random constraints
        c = ceil(rand * n);
        for j = 2:3
            k = ceil(rand * n);
            while any(c == k)
                k = ceil(rand * n);
            end
            c = [c; k]; %#ok<AGROW>
        end

        % Build the least squares matrices
        A = [];
        b = [];
        for j = 1:3
            x = p0(1,c(j));
            y = p0(2,c(j));
            A = [A; wght(j)*[x 0 y 0 1 0; 0 x 0 y 0 1]]; %#ok<AGROW>
            b = [b; wght(j)*p1(:,c(j))]; %#ok<AGROW>
        end

        % Solve for the affine tranform
        aff = pinv(A)*b;
        aff = [aff(1:2) aff(3:4) aff(5:6); 0 0 1];

        % Compute the residuals
        pts = aff * [p0; ones(1,n)];
        resid = sqrt(sum((pts(1:2,:) - p1).^2,1));

        % Save the transformation that has the lowest median residual
        if median(resid) < best_median
            % best_seed = c;
            best_median = median(resid);
            best_aff = aff;
        end

    end
    aff = best_aff;
else
    aff = init_aff;
end

% Perform reweighted least squares to improve the estimate of
% the affine transform.
for k = 1:10
    % Compute the residuals
    pts = aff * [p0; ones(1,n)];
    resid = sqrt(sum((pts(1:2,:) - p1).^2,1))';

    % Compute the contraint weights
    sigma = 1.4826*median(resid);
    dev = resid/sigma;
    resid_wght = exp(-(dev.^2)/2)/(sqrt(2*pi)*sigma);
    resid_wght( (dev>5.0) ) = 0;

    % Build the least squares matrices
    A = [];
    b = [];
    for j = 1:n
        x = p0(1,j);
        y = p0(2,j);
        A = [A; resid_wght(j)*wght(j)*[x 0 y 0 1 0; 0 x 0 y 0 1]]; %#ok<AGROW>
        b = [b; resid_wght(j)*wght(j)*p1(:,j)]; %#ok<AGROW>
    end

    % Solve for the affine tranform
    aff = pinv(A)*b;
    aff = [aff(1:2) aff(3:4) aff(5:6); 0 0 1];
end

% Estimate error in the affine transformation
for k = 1:20
    % Compute the residuals
    pts = aff * [p0; ones(1,n)];
    resid = sqrt(sum((pts(1:2,:) - p1).^2,1))';

    % Compute the contraint weights
    sigma = 1.4826*median(resid);
    errors = randn(size(p1))*diag(resid/3);
    % Build the least squares matrices
    A = [];
    b = [];
    for j = 1:n
        x = p0(1,j);
        y = p0(2,j);
        A = [A; resid_wght(j)*wght(j)*[x 0 y 0 1 0; 0 x 0 y 0 1]]; %#ok<AGROW>
        b = [b; resid_wght(j)*wght(j)*(p1(:,j)+errors(:,j))]; %#ok<AGROW>
    end

    % Solve for the affine tranform
    aff = pinv(A)*b;
    aff = [aff(1:2) aff(3:4) aff(5:6); 0 0 1];
    affsave(:,:,k) = aff; %#ok<AGROW>
    residsave(k) = median(resid); %#ok<AGROW>
end

% Determine which constraints were outliers
if nargout >= 2
    pts = aff * [p0; ones(1,n)];
    resid = sqrt(sum((pts(1:2,:) - p1).^2,1))';
    outliers = find(resid > 2.5*sigma);
end

% Determine the mean squared error
if nargout >= 3
    robustError = mean(resid( (resid <= 2.5*sigma) ));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Detects Harris corners
function [HCF,wind] = harrisCornerDetector(I,options)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% HARRIS CORNER DETECTOR
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% INPUT CONDITIONING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% if input image is multi-channel, convert to grayscale
if size(I,3)>1
    if size(I,3) == 3
        I = rgb2gray(I);
    else
        I = I(:,:,1);
    end
end
% if 'options' is not provided, create empty variable
if ~exist('options','var')
    options = [];
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% PARAMETERS AND CONSTANTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% minimum and maximum number of features to be returned by the program
if isfield(options,'min_N')
    min_N = options.min_N;
else
    min_N = 12;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isfield(options,'max_N')
    max_N = options.max_N;
else
    max_N = max( 200 , min_N + 100 );
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% sigma
if isfield(options,'Sigma')
    Sigma = options.Sigma;
else
    Sigma = 3;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% threshold
if isfield(options,'threshold')
    threshold = options.threshold;
else
    threshold = 10;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% size of order-filtering
if isfield(options,'sze')
    sze = options.sze;
else
    sze = 2*(6) + 1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% k
if isfield(options,'k')
    k = options.k;
else
    k = 0.04;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% half-width of window around feature to return back so as to compute correlation
if isfield(options,'W')
    W = options.W;
else
    W = 3;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% display on or off
if isfield(options,'displ')
    displ = logical(options.displ);
else
    displ = false;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% gradient masks
dx = [-1 0 1; -1 0 1; -1 0 1];
dy = dx';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% make the maximum value of R11 as maxVal (hardcoded as 1000 here)
maxVal = 1000;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% leave out first and last 'pad' columns and rows and compute the sum over the remaining central
% area of R11 (hardcoded as 5 here)
pad = 5;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% MAIN PROCESSING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compute x and y gradient maps
Ix = conv2(I, dx, 'same');
Iy = conv2(I, dy, 'same');
% filter size; 1 if 6*sigma < 1
hsize = max(1,floor(6*Sigma));
% Gaussian filter
g = fspecial('gaussian', hsize, Sigma);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% get 2nd derivatives
Ix2 = conv2(Ix.^2, g, 'same');
Iy2 = conv2(Iy.^2, g, 'same');
Ixy = conv2(Ix.*Iy, g,'same');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% determinant - k*trace^2 of the Hessian of the image
R11 = (Ix2.*Iy2 - Ixy.^2) - k*(Ix2 + Iy2).^2;
% make the maximum value of R11 as maxVal
R = maxVal*R11/max(R11(:));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2D order-statistic filtering - replacing every square area of side 'sze' by its minimum value
MX = ordfilt2(R,sze^2,ones(sze));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% if this is the minimum (from the order-statistic filtering above) AND it is higher than the
% threshold, we keep it
R11 = ( R==MX ) & ( R > threshold );
% leave out first and last 'pad' columns and rows and compute the sum over the remaining central
% area
count = sum( sum( R11( pad:size(R11,1)-pad , pad:size(R11,2)-pad ) ) );
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% REPEAT MAIN PROCESSING UNTIL MINIMUM AND MAXIMUM CONSTRAINTS SATISFIED
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% loop and change the threshold appropriately until we satisfy the minimum and maximum number of
% Harris corner features required
loop = 0;
while ((count < min_N) || (count > max_N)) && (loop<30)
    if count > max_N
        % if we have more corner features than maximum allowed, increase the threshold so as to
        % reduce the number of corner features returned
        threshold = 1.5 * threshold;
    elseif count < min_N
        % if we have lesser corner features than minimum allowed, decrease the threshold so as to
        % increase the number of corner features returned
        threshold = threshold / 2;
    end
    % if this is the minimum (from the order-statistic filtering above) AND it is higher than the
    % threshold, we keep it
    R11 = ( R==MX ) & ( R > threshold );
    % leave out first and last 'pad' columns and rows and compute the sum over the remaining central
    % area
    count = sum( sum( R11( pad:size(R11,1)-pad , pad:size(R11,2)-pad ) ) );
    % increment the loop counter
    loop = loop + 1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% GET HARRIS CORNER FEATURES AND IMAGE WINDOWS AROUND CORNERS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% zero out R
R = zeros(size(R));
% copy the central area of R11 over to R
R( pad:size(R11,1)-pad , pad:size(R11,2)-pad ) = R11( pad:size(R11,1)-pad , pad:size(R11,2)-pad );
% find the feature points
[r1,c1] = find(R);
% Harris Corner Features
HCF = [r1,c1];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% windows around feature to return back so as to compute correlation
wind = cell(1,size(HCF,1));
for i = 1:size(HCF,1);
    wind{i} = I( HCF(i,1)-W:HCF(i,1)+W , HCF(i,2)-W:HCF(i,2)+W );
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% DISPLAY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if displ
    for r = 1:size(HCF,1)
        I( HCF(r,1)-2:HCF(r,1)+2 ,      HCF(r,2)-2      ) = 1;
        I( HCF(r,1)-2:HCF(r,1)+2 ,      HCF(r,2)+2      ) = 1;
        I(      HCF(r,1)-2       ,HCF(r,2)-2:HCF(r,2)+2 ) = 1;
        I(      HCF(r,1)+2       ,HCF(r,2)-2:HCF(r,2)+2 ) = 1;
    end
    figure; imshow(I,[])
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Computes the L2 distance
function D = L2_distance(X,Y,varargin)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% X is an N-by-d matrix where each row is an observation in d dimensions
% Y is an M-by-d matrix where each row is an observation in d dimensions
% A is a distance metric
% D is the L2 distance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nX,dX] = size(X);
[nY,dY] = size(Y);
if dX~=dY
    % if the #columns of X and Y do not match
    if nX==nY
        % if the other dimension matches, transpose the matrices so that the #columns match
        X = X'; [nX,dX] = size(X);
        Y = Y'; [nY,dY] = size(Y); %#ok<NASGU>
        d = dX;
    else
        % if neither dimension matches, show error
        error('Input matrices should have same row dimensions ')
    end
else
    % if the #columns match, then this is the dimension
    d = dX;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin>2
    A = varargin{1};
    if nargin>3
        L = varargin{2};
    else
        L = chol(A);
    end
else
    A = eye(d);
    L = eye(d);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N = nX; M = nY;
% distance matrix of ith element of X vs. jth element of Y
D = zeros(N,M);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isequal(X,Y) && (nX==nY)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % if we are comparing the self-distances of a set of vectors we only need to run j loop from i+1
    % to N, and the distance matrix is symmetric
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ~isequal(A,eye(d))
        % if it is a Mahalanobis metric
        X = X*L';
        Y = X;
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for i = 1:N
        for j = i+1:N
            D(i,j) = (X(i,:)-Y(j,:))*(X(i,:)-Y(j,:))';
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % make sure it is symmetric
    D = D + D';
    D = min(D,D');
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
else
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % else if we are comparing the distances of two different sets of vectors we must run the i and
    % j loops fully
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ~isequal(A,eye(d))
        % if it is a Mahalanobis metric
        X = X*L';
        Y = Y*L';
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for i = 1:N
        for j = 1:M
            D(i,j) = (X(i,:)-Y(j,:))*(X(i,:)-Y(j,:))';
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
D = sqrt(D);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Computes the feature correspondences based on SVD
function C = svdFeatCorresp(FPa, FPb, Wa, Wb, sigma, corr_th)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%       Singular Value Decomposition Feature Matching
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Obtained from the paper 'A Direct Method for Stereo Correspondence based on Singular Value
% Decomposition' by Maurizio Pilu, in IEEE CVPR 1997
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% sigma :       adjust point interaction (expected displacement)
% corr_th :     minimum acceptable correlation for a match
% C :           feature mapping matrix - C(i,j) = 1 when 1:1 correspondence
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% number of features in image A
m = size(FPa,1);
% number of features in image B
n = size(FPb,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compute the m x n matrix of correlations between features in opposite images
point_corr = zeros(m,n);
for i = 1:m
    for j = 1:n
        point_corr(i,j) = corr2(Wa{i},Wb{j});
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compute the m x n matrix of distances between features in opposite images
point_dist = L2_distance(FPa,FPb);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Build correspondence strength matrix
G = (point_corr+1)/2 .* exp( - point_dist.^2/(2*sigma^2));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Perform SVD and extract orthogonal matrix P
[T,D,U] = svd(G);
D = eye(m,n);
P = T * D * U';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Find dominant of each line and column
[V, I] = max(P);
[V, J] = max(P,[],2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialize correspondence matrix C
C = zeros(m,n);
% Set a one-to-one correspondence between Ii and Jj only if P(i,j) is MAX of both row i and column j
% AND their correlation in above corr_th
for i = 1:length(J)
    if I(J(i)) == i
        if ( point_corr(i,J(i)) > corr_th )
            C(i,J(i)) = 1;
        end
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Loads an image from the video
function [im,vidinfo,videoName] = LoadImage(videoName,frameNum,varargin)

if nargin > 2
    vidinfo = varargin{1};
    if vidinfo.useMMreader
        im = read(videoName,frameNum);
        return;
    else
        im = aviread(videoName,frameNum);
        if isempty(strfind(videoName,'&'))
            im = im.cdata(:,:,[2 3 1]); for i = 1:3, im(:,:,i) = [im(:,end-8:end,i) im(:,1:end-9,i)]; end
        else
            im = im.cdata;
        end
        return;
    end
elseif nargin == 2
    if isa(videoName,'mmreader')
        im = read(videoName,frameNum);
        vidinfo = get(videoName);
        vidinfo.NumFrames = vidinfo.NumberOfFrames;
        vidinfo.useMMreader = true;
        return;
    elseif ischar(videoName)
        try
            im = aviread(videoName,frameNum);
            if isempty(strfind(videoName,'&'))
                im = im.cdata(:,:,[2 3 1]); for i = 1:3, im(:,:,i) = [im(:,end-8:end,i) im(:,1:end-9,i)]; end
            else
                im = im.cdata;
            end
            vidinfo = aviinfo(videoName);
            vidinfo.useMMreader = false;
            return;
        catch ME
            err = regexp(ME.identifier, '(?<=:)\w+$','match');
            if strcmpi(err,'invalidCodec') || strcmpi(err,'incorrectChunkSize')
                videoName = mmreader(videoName);
                im = read(videoName,frameNum);
                vidinfo = get(videoName);
                vidinfo.NumFrames = vidinfo.NumberOfFrames;
                vidinfo.useMMreader = true;
                return;
            end
        end
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Computes superpixel segmentation
function imgdesc = ComputeSuperPixels(img,params)
% params -  parameters regarding what features to use in the covariance descriptor
% % debugging
% clear all; close all; clc; img = imread('peppers.png');
h = waitbar(0,'Please wait...');
if ~exist('params','var')
    params = [];
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% superpixel segmentation - calling executable file
imwrite(img,'orig_image.ppm');
% tic;
[status, result] = dos('superpixels.exe 1 500 500 orig_image.ppm spixel.ppm');
% fprintf('superpixels.exe took %.5f seconds\n',toc);
waitbar(0.5,h,'Superpixel segmentation complete!');
if status
    disp(result)
    error('Superpixel code cannot run!!!');
end
simg = double(imread('spixel.ppm'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
simg = simg(:,:,1)*10^6 + simg(:,:,2)*10^3 + simg(:,:,3);
[r,c] = size(simg);
mask_image = reshape(grp2idx(reshape(simg,r*c,1)),r,c);
imgdesc.simg = uint8(mask_image);

labels = unique(mask_image);
imgdesc.segments = length(labels);
imgdesc.area = zeros(imgdesc.segments,1);
masks = repmat(struct('mask',[]),1,imgdesc.segments);
for k = 1 : imgdesc.segments
    masks(k).mask = ( mask_image == k );
    imgdesc.area(k) = nnz(masks(k).mask);
end
waitbar(0.7,h,'Computing region descriptors...');
imgdesc.covmats = computeCovarianceDescriptor(img,masks,params);
imgdesc.annot = cell(1,imgdesc.segments);
waitbar(1.0,h,'Done! Thank you for waiting!'); pause(0.1); close(h);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Computes covariance descriptors over image regions
function covmats = computeCovarianceDescriptor(inpImage,masks,params) %#ok<INUSD>

if ischar(inpImage)
    inpImage = imread(inpImage);
end
if isa(masks,'double')
    masks = logical(masks);
end
if isa(masks,'logical')
    tmp = masks; clear masks; masks(1).mask = tmp; clear tmp;
else
    if isstruct(masks) && ~isfield(masks,'mask')
        error('Mask field missing!');
    end
end

I = im2double(inpImage);
im = I;
[r,c,d] = size(im);

if d==3
    I = rgb2gray(I);
end

[Ix,Iy] = gradient(I);
d = d + 1; im(:,:,d) = abs(Ix);
d = d + 1; im(:,:,d) = abs(Iy);
d = d + 1; im(:,:,d) = atan2(Iy,Ix);
d = d + 1; im(:,:,d) = sqrt(Ix.^2 + Iy.^2);

[Ixx,Ixy] = gradient(Ix);
d = d + 1; im(:,:,d) = abs(Ixx);
d = d + 1; im(:,:,d) = abs(Ixy);

[Iyx,Iyy] = gradient(Iy);
d = d + 1; im(:,:,d) = abs(Iyy);

% [X,Y] = meshgrid(1:c,1:r);
% d = d + 1; im(:,:,d) = X;
% d = d + 1; im(:,:,d) = Y;


% regularization
regMat = 1e-10 * eye(d);

X = reshape(im,r*c,d);
covmats = cell(size(masks));
for i = 1:length(masks)
    covmats{i} = cov(X(masks(i).mask(:),:),1);
    if nnz(isnan(covmats{i})) || nnz(isinf(covmats{i})) || (nnz(masks(i).mask)==0)
        disp(covmats{i})
        error('nan or inf in cov mat')
    end
    covmats{i} = covmats{i} + regMat;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Assigns manually labeled annotations to segmented image regions
function imgdesc = assignAnnotations(manualAnnotation,imgdesc,allLabels)
% manualAnnotation  - annots.masks{id(i)}
% imgdesc           - imgdesc(i)
% allLabels         - annots.labels
h = waitbar(0,'Please wait...');
manual_masks = cell(1,length(unique(manualAnnotation)));
for i = unique(manualAnnotation)'
    if i~=0
        manual_masks{i} = manualAnnotation == i;
    end
end
imgdesc.annot = cell(1,imgdesc.segments);
waitbar(0,h,'Processing...');
for i = 1:imgdesc.segments
    mask = imgdesc.simg == i;
    uniqLabels = double(unique(manualAnnotation(mask))); uniqLabels(uniqLabels == 0) = [];
    if isempty(uniqLabels)
        imgdesc.annot(i) = {'nan'};
    elseif length(uniqLabels) == 1
        imgdesc.annot(i) = allLabels(uniqLabels);
    else
        e = -inf(1,max(uniqLabels));
        for j = uniqLabels'
            jthoverlap = manual_masks{j} & imfill(~manual_masks{j},find(manual_masks{j} & mask,1));
            e(j) = nnz(mask & jthoverlap)/nnz(jthoverlap);
        end
        imgdesc.annot(i) = allLabels( find(e==max(e),1) );
    end
    waitbar(i/imgdesc.segments,h);
end
ind = strcmpi([imgdesc.annot],'nan');
imgdesc.annot(ind) = [];
imgdesc.area(ind) = [];
imgdesc.covmats(ind) = [];
imgdesc.segments = length(imgdesc.area);
waitbar(1,h,'Done! Thank you for waiting!'); pause(0.1); close(h);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Performs automatic annotation
function performAutomaticAnnotation(im,Annotator,imgAxes,handles)
% ---------------------------------------------------------------------------------------------------------------------------
% PERFORMS AUTOMATIC ANNOTATION USING Annotator ON FRAME frameNum FROM VIDEO testFileName
% DATE      :   10th November 2009
% TIME      :   1:30 PM
% AUTHOR    :   RAVISHANKAR SIVALINGAM
% ---------------------------------------------------------------------------------------------------------------------------
testimg = ComputeSuperPixels(im); drawnow; rp = regionprops(testimg.simg,'all');
normalizer = diag( 1./( Annotator.histY.*( (2*pi*Annotator.sig2).^(Annotator.dim/2) ) ) );
% KDE
priors = zeros(testimg.segments,Annotator.K);
if length(Annotator.X)>1000
    ind = randsample(length(Annotator.X),1000);
else
    ind = 1:length(Annotator.X);
end
Dtesttrain = ComputeGeodesicDistanceLambda(testimg.covmats,Annotator.X(ind));
for i = 1:testimg.segments
    priors(i,:) = exp( - 0.5 * Dtesttrain(i,:) ./ Annotator.sig2(Annotator.Y(ind)) ) * Annotator.indicatorMatrix(ind,:) * normalizer;
end
[a,b] = sort(priors,2,'descend'); predLabelIDs = b(:,1);
save Annottmp
% mask = a(:,2)./a(:,1) > 0.25; 
% [n1,n2] = sort(Dtesttrain(mask,:),2,'ascend'); 
% if nnz(mask)==1
%     predLabelIDs(mask) = mode(Annotator.Y(n2(:,1:10))); % doing 10-NN when uncertain
% else
% predLabelIDs(mask) = mode(Annotator.Y(n2(:,1:10)),2); % doing 10-NN when uncertain
% end
% tid = find( predLabelIDs==find(strcmpi('car',Annotator.labels)) ); tid = tid([rp(tid).Eccentricity]>.95); 
% [n1,n2] = sort(Dtesttrain(tid,:),2,'ascend');
% if length(tid)==1
%     predLabelIDs(tid) = mode(Annotator.Y(n2(:,1:10)));
% else    
%     predLabelIDs(tid) = mode(Annotator.Y(n2(:,1:10)),2);
% end
mask = a(:,1)./a(:,2) > 10;
[n1,n2] = sort(Dtesttrain,2,'ascend'); predLabelIDs = mask.*b(:,1) + (~mask).*mode(Annotator.Y(n2(:,1:25)),2);
tid = find( predLabelIDs==find(strcmpi('car',Annotator.labels)) ); tid = tid([rp(tid).Eccentricity]>.95);  
for i = 1:length(tid)
    tmp = b(tid(i),:); tmp(tmp==find(strcmpi('car',Annotator.labels))) = []; predLabelIDs(tid(i)) = tmp(1);
end
% tid = find([rp.Solidity]<0.3);
D = makenhoodgraph(testimg.simg);
[n1,n2] = find(D>.055);
for i = 1:length(n1)
    if ( rp(n1(i)).Area > 5*rp(n2(i)).Area ) && (a(n2(i),1)/a(n2(i),2)<5)
        predLabelIDs(n2(i)) = predLabelIDs(n1(i));        
    elseif ( 5*rp(n1(i)).Area < rp(n2(i)).Area ) && (a(n1(i),1)/a(n1(i),2)<5)
        predLabelIDs(n1(i)) = predLabelIDs(n2(i));
    end
end

% for i = -2:2
%     testimg(i+3) = ComputeSuperPixels(LoadImage(handles.fullfilename,handles.framenum+i*5,handles.vidinfo));
% end
% for i = 1:length(testimg), testimg(i).newsimg = zeros(size(testimg(i).simg)); end
% normalizer = diag( 1./( Annotator.histY.*( (2*pi*Annotator.sig2).^(Annotator.dim/2) ) ) );
% % KDE
% priors = zeros(sum([testimg.segments]),Annotator.K);
% if length(Annotator.X)>1000
%     ind = randsample(length(Annotator.X),1000);
% else
%     ind = 1:length(Annotator.X);
% end
% Dtesttrain = ComputeGeodesicDistanceLambda([testimg.covmats],Annotator.X(ind));
% for i = 1:sum([testimg.segments])
%     priors(i,:) = exp( - 0.5 * Dtesttrain(i,:) ./ Annotator.sig2(Annotator.Y(ind)) ) * Annotator.indicatorMatrix(ind,:) * normalizer;
% end
% [a,b] = sort(priors,2,'descend'); predLabelIDs = b(:,1);
% mask = a(:,1)./a(:,2) > 5;
% [n1,n2] = sort(Dtesttrain,2,'ascend'); predLabelIDs = mask.*b(:,1) + (~mask).*mode(Annotator.Y(n2(:,1:100)),2);
% for i = 1:length(predLabelIDs)
%     tmp = i; k = 1;
%     while tmp>testimg(k).segments
%         tmp = tmp-testimg(k).segments; k = k+1;
%     end
%     testimg(k).newsimg(testimg(k).simg==tmp) = predLabelIDs(i);
% end
% save AnnotNewIdea

Annot.annots = Annotator.labels(predLabelIDs);
save Annot
old_labels = unique(testimg.simg);
newsimg = zeros(size(testimg.simg));
for i = 1:length(old_labels)
    if ~isempty(Annot.annots{i})
        newsimg(testimg.simg==old_labels(i)) = find(strcmpi(Annotator.labels,Annot.annots{i}));
    end
end
axes(imgAxes); cla;
save AnnotIdea
DisplayOverlay(Annotator.labels,im,newsimg,imgAxes,true);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Converts alphanumeric X into indices and labels
function [Y,indicatorMatrix,histY,wordlist] = histWords(X,varargin)
% converts alphanumeric X into indices and labels

N = length(X);

if nargin == 2
    wordlist = varargin{1};
    Y = zeros(N,1);
    for k = 1:length(wordlist)
        Y(strcmpi(X,wordlist{k})) = k;
    end
else
    [Y,wordlist] = grp2idx(X);
end
K = length(wordlist);

indicatorMatrix = false(N,K);
for k = 1:K
    indicatorMatrix(:,k) = ( Y==k );
end
indicatorMatrix = sparse(indicatorMatrix);

histY = full(sum(indicatorMatrix)) + 1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Learns the KDE bandwidth for each class in the training set
function sig2 = learnKDEbandwidth(X,Y,K,varargin)
% uY = unique(Y); uY(uY==0) = []; K = length(uY);
sig2 = zeros(1,K);

if nargin == 4
    % if D is provided, pass it on to the sub-function
    D = varargin{1};
    for k = 1:K
        sig2(k) = learnBandwidth( X(Y==k) , D(Y==k,Y==k) );
    end
else
    for k = 1:K
        if nnz(Y==k)
            sig2(k) = learnBandwidth( X(Y==k) );
        else
            sig2(k) = 1e-10;
        end
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Learns the kernel bandwidth from the data points
function sig2 = learnBandwidth(X,varargin)
% Highly optimized version of the kernel bandwidth learning algorithm of 'Algorithms for Gaussian Bandwidth Selection in
% Kernel Density Estimators' by Jose Miguel Leiva Murilla and Antonio Artes Rodriguez
if nargin == 2
    % if D is provided
    D = varargin{1};
else
    % else compute for a maximum of 200 points only
    N = length(X); maxsize = 200;
    if N > maxsize, X = X(randsample(N,maxsize)); end
    D = ComputeGeodesicDistanceLambda(X,X);
end
N = length(X);
D = reshape(D(~eye(N)),N-1,N);
dim = size(X{1},1);

new_sig2 = 1.1236 * (N^0.4);
for trial = 1:25
    sig2 = new_sig2;
    G = exp( -0.5 * D / sig2 ) / ( (2*pi*sig2)^(dim/2) );
    new_sig2 = ((1./mean(G))*diag(D'*G))/(N*(N-1)*dim);
    if abs(sig2-new_sig2) < 1e-3, break; end
end
sig2 = new_sig2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Creates co-occurrence matrix from data set
function [COMat,termdocMatrix] = createCoOccurrenceMatrix(imgdesc,labels)
numdocs = length(imgdesc);
numlabels = length(labels);
termdocMatrix = zeros(numlabels,numdocs);
for i = 1:numdocs
    for j = 1:numlabels
        termdocMatrix(j,i) = nnz(strcmpi(imgdesc(i).annot,labels{j}));
    end
end
COMat = termdocMatrix * termdocMatrix';
COMat = COMat + eye(length(COMat)); % regularization
COMat = ( COMat/diag(sum(COMat)) ); % divide row i by item(i,i).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles,'figure1')
    set(handles.figure1,'Units','Pixels')
    set(handles.uipanel2,'Units','Pixels')
    set(handles.uipanel1,'Units','Pixels')
    set(handles.cbOverlay,'Units','Pixels')
    set(handles.pbNext,'Units','Pixels')
    set(handles.pbPrevious,'Units','Pixels')
    set(handles.tbTotalFrames,'Units','Pixels')
    set(handles.tbframeNum,'Units','Pixels')
    set(handles.imgAxes,'Units','Pixels')
    set(handles.pbLoadVideo,'Units','Pixels')
    set(handles.cbLoaded,'Units','Pixels')
    set(handles.pbTest,'Units','Pixels')
    set(handles.pbTrain,'Units','Pixels')
    set(handles.pbDelAll,'Units','Pixels')
    set(handles.pbFillAll,'Units','Pixels')
    set(handles.pbProp,'Units','Pixels')
    set(handles.pbDelete,'Units','Pixels')
    set(handles.pbFill,'Units','Pixels')
    set(handles.pbSuggAnnot,'Units','Pixels')
    set(handles.tbStartAnnot,'Units','Pixels')
    set(handles.pbSegment,'Units','Pixels')
end
